#include "../common/common.h"

#include "stack.h"

/* add command */
class add : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	add(void) {}

	add(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		_debug("add %f %f", a, b);

		stack_push(a + b);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/add";
	}
};

DECLARE_COMMAND_EX(add, "add");

DECLARE_EMPTY_STORAGE(add, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(add, version_command_t);