#include "../common/common.h"

#include "stack.h"

/* div command */
class divide : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	divide(void) {}

	divide(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		_debug("divide %f %f", a, b);

		if (b == 0)
			throw_exception(division_by_zero_exception);

		stack_push(a / b);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/div";
	}
};

DECLARE_COMMAND_EX(divide, "div");

DECLARE_EMPTY_STORAGE(divide, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(divide, version_command_t);