#include "../common/common.h"

#include "stack.h"

/* mult command */
class mult : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	mult(void) {}

	mult(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		_debug("mult %f %f", a, b);

		stack_push(a * b);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/mult";
	}
};

DECLARE_COMMAND_EX(mult, "mult");

DECLARE_EMPTY_STORAGE(mult, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(mult, version_command_t);