#include "../common/common.h"

#include "stack.h"

/* over command */
class over : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	over(void) {}

	over(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		_debug("over %f %f", a, b);

		stack_push(a);
		stack_push(b);
		stack_push(a);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/over";
	}
};

DECLARE_COMMAND_EX(over, "over");

DECLARE_EMPTY_STORAGE(over, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(over, version_command_t);