#include "../common/common.h"

#include "stack.h"

/* print command */
class print : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	print(void) {}

	print(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto val = stack_top();

#ifdef WIN32
		printf("value = %f\r\n", val);
#else
		printf("value = %f\n", val);
#endif
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/print";
	}
};

DECLARE_COMMAND_EX(print, "print");

DECLARE_EMPTY_STORAGE(print, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(print, version_command_t);