#include "../common/common.h"

#include "stack.h"

/* push command */
class pushcmd : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	pushcmd(const double value = 0)
	{
		this->m_value = value;
	}

	pushcmd(const std::vector<std::string>& args)
	{
		if (args.size() != 1)
			throw_exception(invalid_number_of_arguments_exception);

		this->m_value = atof(args[0].c_str());
	}

	virtual void run(void) const override
	{
		stack_push(this->m_value);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/" + format("push %f", this->m_value);
	}

private:
	double m_value;
};

BEGIN_STORAGE(pushcmd)
{
	DECLARE_STORAGE(pushcmd, m_value),
} END_STORAGE(pushcmd, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(pushcmd, version_command_t);

DECLARE_COMMAND_EX(pushcmd, "push");