#include "../core/debug/evemon.h"

#include "stack.h"

#include <stack>

std::stack<double> g_stack;

// pop item from stack
double stack_pop(void)
{
	if (g_stack.empty())
		throw_exception(empty_stack_exception);

	auto val = g_stack.top();

	_debug("pop %f", val);

	g_stack.pop();

	return val;
}

// get top item of stack
double stack_top(void)
{
	if (g_stack.empty())
		throw_exception(empty_stack_exception);

	return g_stack.top();
}

// push item to stack
void stack_push(const double val)
{
	_debug("push %f", val);

	g_stack.push(val);
}