#include "../common/common.h"

#include "stack.h"

/* sub command */
class subtract : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	subtract(void) {}

	subtract(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		_debug("subtract %f %f", a, b);

		stack_push(a - b);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/sub";
	}
};

DECLARE_COMMAND_EX(subtract, "sub");

DECLARE_EMPTY_STORAGE(subtract, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(subtract, version_command_t);