#include "../common/common.h"

#include "stack.h"

/* swap command */
class swap : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	swap(void) {}

	swap(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		_debug("swapping %f %f", a, b);

		stack_push(a);
		stack_push(b);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/swap";
	}
};

DECLARE_COMMAND_EX(swap, "swap");

DECLARE_EMPTY_STORAGE(swap, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(swap, version_command_t);