#include "../common/common.h"

#include "stack.h"
#include "csg.h"

/* cut command */
class cut : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	cut(void) {}

	cut(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		stack_push(std::make_shared<csg::bit_and>(b, std::make_shared<csg::bit_not>(a)));
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/cut";
	}
};

DECLARE_EMPTY_STORAGE(cut, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(cut, version_command_t);

DECLARE_COMMAND_EX(cut, "cut");