#include "../common/common.h"

#include "stack.h"

/* drop command */
class drop : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	drop(void) {}

	drop(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		stack_pop();
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/drop";
	}
};

DECLARE_COMMAND_EX(drop, "drop");

DECLARE_EMPTY_STORAGE(drop, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(drop, version_command_t);