#include "../core/exception.h"

#include "../common/common.h"

#include "stack.h"

/* dup command */
class dupcmd : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	dupcmd(void) {}

	dupcmd(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto p = stack_top();

		if (p == nullptr)
			throw_exception(null_pointer_exception);

		stack_push(p->clone());
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/dup";
	}
};

DECLARE_COMMAND_EX(dupcmd, "dup");

DECLARE_EMPTY_STORAGE(dupcmd, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(dupcmd, version_command_t);
