#include "../common/common.h"

#include "stack.h"
#include "csg.h"

/* fusion command */
class fusion : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	fusion(void) {}

	fusion(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		stack_push(std::make_shared<csg::bit_or>(b, a));
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/fusion";
	}
};

DECLARE_EMPTY_STORAGE(fusion, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(fusion, version_command_t);

DECLARE_COMMAND_EX(fusion, "fusion");