#include "../common/common.h"

#include "stack.h"
#include "csg.h"

/* intersect command */
class intersect : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	intersect(void) {}

	intersect(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();

		stack_push(std::make_shared<csg::bit_and>(b, a));
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/intersect";
	}
};

DECLARE_EMPTY_STORAGE(intersect, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(intersect, version_command_t);

DECLARE_COMMAND_EX(intersect, "intersect");