#include "../common/common.h"

#include "stack.h"
#include "csg.h"

/* invert command */
class invert : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	invert(void) {}

	invert(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		stack_push(std::make_shared<csg::bit_not>(stack_pop()));
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/invert";
	}
};

DECLARE_EMPTY_STORAGE(invert, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(invert, version_command_t);

DECLARE_COMMAND_EX(invert, "invert");