#include "../common/common.h"

#include "stack.h"
#include "csg.h"

/* move command */
class move : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	move(void)
	{
		this->m_x = 0;
		this->m_y = 0;
	}

	move(const std::vector<std::string>& args)
	{
		if (args.size() != 2)
			throw_exception(invalid_number_of_arguments_exception);

		this->m_x = atof(args[0].c_str());
		this->m_y = atof(args[1].c_str());
	}

	virtual void run(void) const override
	{
		stack_push(std::make_shared<csg::move>(stack_pop(), this->m_x, this->m_y));
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/" + format("move %f %f", this->m_x, this->m_y);
	}

private:
	double m_x, m_y;
};

BEGIN_STORAGE(move)
{
	DECLARE_STORAGE(move, m_x),
	DECLARE_STORAGE(move, m_y),
} END_STORAGE(move, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(move, version_command_t);

DECLARE_COMMAND_EX(move, "move");