#include "../common/common.h"

#include "stack.h"

/* rot command */
class rot : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	rot(void) {}

	rot(const std::vector<std::string>& args)
	{
		if (args.size() != 0)
			throw_exception(invalid_number_of_arguments_exception);
	}

	virtual void run(void) const override
	{
		auto a = stack_pop();
		auto b = stack_pop();
		auto c = stack_pop();

		stack_push(b);
		stack_push(c);
		stack_push(a);
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/rot";
	}
};

DECLARE_COMMAND_EX(rot, "rot");

DECLARE_EMPTY_STORAGE(rot, version_command_t);
DECLARE_INSTANCEABLE_OBJECT(rot, version_command_t);