#include "../common/common.h"

#include "stack.h"
#include "csg.h"

/* scale command */
class scale : public textcommand
{
public:
	IMPLEMENT_STORAGE;

	scale(void)
	{
		this->m_val = 0;
	}

	scale(const std::vector<std::string>& args)
	{
		if (args.size() != 1)
			throw_exception(invalid_number_of_arguments_exception);

		this->m_val = atof(args[0].c_str());
	}

	virtual void run(void) const override
	{
		stack_push(std::make_shared<csg::scale>(stack_pop(), this->m_val));
	}

	virtual std::string log(void) const override
	{
		return get_instance<library::manager>()->get_name() + "/" + format("scale %f", this->m_val);
	}

private:
	double m_val;
};

BEGIN_STORAGE(scale)
{
	DECLARE_STORAGE(scale, m_val),
} END_STORAGE(scale, version_command_t);

DECLARE_INSTANCEABLE_OBJECT(scale, version_command_t);

DECLARE_COMMAND_EX(scale, "scale");