#pragma once

#include "../core/debug/exception.h"

#include "../common/common.h"

#include "csg.h"

#include <string>
#include <memory>

/* invalid_number_of_arguments_exception exception class */
class invalid_number_of_arguments_exception : public exception::base
{
public:
	virtual std::string to_string(void) const
	{
		return "an invalid number of arguments was provided!";
	}
};

/* empty_stack_exception exception class */
class empty_stack_exception : public exception::base
{
public:
	virtual std::string to_string(void) const override
	{
		return "Stack is empty!";
	}
};

std::shared_ptr<csg::base> stack_top(void);
std::shared_ptr<csg::base> stack_pop(void);
void stack_push(std::shared_ptr<csg::base>);